<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="generator" content="https://txt2tags.org">
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
</hgroup>
</header>


<div class="body">

<section>
<h1>Shebang e Outros Paranauês</h1>

<p>
<strong><em>Colaboração: Paulo Roberto Bagatini</em></strong>
</p>
<p>
<strong><em>Data de Publicação:</em></strong>
</p>

<pre class="comandos">
<span class="saida">#!/bin/sh</span>
<span class="saida">#!/bin/bash</span>
<span class="saida">#!/usr/bin/bash</span>
<span class="saida">#!/usr/local/bin/bash</span>
<span class="saida">#!/usr/bin/env bash</span>
</pre>

<pre class="comandos">
<span class="saida">java --version</span>
<span class="saida"># openjdk 21.0.3 2024-04-16</span>

<span class="saida">url=https://github.com/Teradata/jaqy/releases/download/v1.2.0/jaqy-1.2.0.jar</span>
<span class="saida">{ echo '#!/usr/bin/env -S java -jar'; curl -sL $url; } &gt; jaqy</span>

<span class="saida">head -n1 jaqy</span>
<span class="saida"># #!/usr/bin/env -S java -jar</span>

<span class="saida">chmod +x jaqy</span>

<span class="saida">./jaqy -v</span>
<span class="saida"># Jaqy Console 1.2.0</span>

<span class="saida">jar tvf  jaqy META-INF/MANIFEST.MF</span>
<span class="saida">#    351 Tue Aug 10 22:03:36 BRT 2021 META-INF/MANIFEST.MF</span>

<span class="saida">unzip -p jaqy META-INF/MANIFEST.MF</span>
<span class="saida"># warning [jaqy]:  28 extra bytes at beginning or within zipfile</span>
<span class="saida">#   (attempting to process anyway)</span>
<span class="saida"># Manifest-Version: 1.0</span>
<span class="saida"># Implementation-Title: Jaqy Console</span>
</pre>

<pre class="comandos">
<span class="saida">url=https://gitlab.com/arkanon/misc/show_tz.java/-/raw/master/show_tz.java</span>
<span class="saida">{ echo '#!/usr/bin/env -S java --source 19'; curl -sL $url; } &gt; show_tz</span>
<span class="saida">chmod +x ./show_tz</span>

<span class="saida">./show_tz</span>
<span class="saida"># Versão do Java     : 21.0.3</span>
<span class="saida"># Class file         : /media/5tb-data/src/git/gitlab.com/dicas-l/dicas/shebang_e_suas_maravilhas/testes/./show_tz</span>
<span class="saida"># Compatibilidade    : 12130 (Java SE 12086)</span>
<span class="saida"># ...</span>
</pre>

<pre class="comandos">
<span class="saida">url=https://gitlab.com/arkanon/misc/show_tz.java/-/raw/master/show_tz.class</span>

<span class="saida">{ echo '#!/usr/bin/env java'; curl -sL $url; } &gt; show_tz</span>
<span class="saida">chmod +x ./show_tz</span>
<span class="saida">./show_tz</span>
</pre>

<p>
Acessar <a href="http://oldversion.com/games/mine-sweeper-xp-6-1">http://oldversion.com/games/mine-sweeper-xp-6-1</a> e salvar o arquivo 6.1_MinesweeperXP.exe. Então:
</p>

<pre class="comandos">
<span class="saida">7z l 6.1_MinesweeperXP.exe</span>
<span class="saida">#    Date      Time    Attr         Size   Compressed  Name</span>
<span class="saida"># ------------------- ----- ------------ ------------  ------------------------</span>
<span class="saida"># 2001-08-23 08:00:00 ....A       119808       135800  Minesweeper XP/winmine.exe</span>
<span class="saida"># 2011-10-14 11:47:29 ....A       176128               Minesweeper XP/winmm.dll</span>
<span class="saida"># 2012-02-27 00:57:21 D....            0            0  Minesweeper XP</span>
<span class="saida"># ------------------- ----- ------------ ------------  ------------------------</span>
<span class="saida"># 2012-02-27 00:57:21             295936       135800  2 files, 1 folders</span>

<span class="saida">7z e 6.1_MinesweeperXP.exe */*</span>
<span class="saida"># Everything is Ok</span>
<span class="saida">#</span>
<span class="saida"># Files: 2</span>
<span class="saida"># Size:       295936</span>
<span class="saida"># Compressed: 298843</span>

<span class="saida">wine --version</span>
<span class="saida"># wine-9.12 (Staging)</span>

<span class="saida">WINEDLLOVERRIDES=mscoree,mshtml= WINEPREFIX=~/.winmine wine winmine.exe</span>
<span class="saida">du -hs ~/.winmine</span>
<span class="saida"># 1,3G    ~/.winmine</span>

<span class="saida">{ echo '#!/usr/bin/env -S WINEDLLOVERRIDES=mscoree,mshtml= WINEPREFIX=~/.winmine wine'; } &gt; winmine</span>
<span class="saida">chmod +x winmine</span>
<span class="saida">./winmine</span>
<span class="saida"># wine: invalid directory ~/.winmine in WINEPREFIX: not an absolute path</span>

<span class="saida">{ echo '#!/usr/bin/env -S WINEDLLOVERRIDES=mscoree,mshtml= WINEPREFIX=$HOME/.winmine wine'; } &gt; winmine</span>
<span class="saida">./winmine</span>
<span class="saida"># /usr/bin/env: Só há suporte à expansão ${VARNAME}, erro em: $HOME/.winmine wine</span>

<span class="saida">{ echo '#!/usr/bin/env -S WINEDLLOVERRIDES=mscoree,mshtml= WINEPREFIX=${HOME}/.winmine wine'; } &gt; winmine</span>
<span class="saida">./winmine</span>

<span class="saida">ps -ef | grep -i [w]in</span>
<span class="saida">WINEPREFIX=${HOME}/.winmine wineserver --kill</span>

<span class="saida">rm 6.1_MinesweeperXP.exe</span>
</pre>

<pre class="comandos">
<span class="saida">{ echo -e '#!/usr/bin/env bash\ntail -n+3 $0 | display; exit'; cat bash.svg; } &gt; bash-logo</span>
<span class="saida">head -n+2 bash-logo</span>
<span class="saida"># #!/usr/bin/env bash</span>
<span class="saida"># tail -n+3 $0 | display; exit</span>
<span class="saida">chmod +x bash-logo</span>
<span class="saida">./bash-logo</span>

<span class="saida">source=inventario.png</span>
<span class="saida">script=${source%.*}</span>
<span class="saida">autoex='#!/usr/bin/env bash\ntail -n+3 $0 | display; exit'</span>
<span class="saida">{ echo -e "$autoex"; cat $source; } &gt; $script</span>
<span class="saida">chmod +x $script</span>
<span class="saida">./$script</span>
</pre>

<section>
<h2>Referências</h2>

 <ul>
 <li><a href="http://wikipedia.org/wiki/Shebang_%28Unix%29">Wikipedia</a>
 </li>
 <li><a href="http://byby.dev/bash-shebang">How to use shebang #! in Bash</a>
 </li>
 <li><a href="http://dev.to/iamthecarisma/shebang-hebang-and-webang-lines-bang-lines-for-compiled-source-files-4eb9">Shebang, Hebang and Webang</a>
 </li>
 </ul>

</section>
<section>
<h2>Comandos usados nesse artigo</h2>

 <ul>
 <li><a href="http://man.archlinux.org/man/7z.1">7z</a>
 </li>
 <li><a href="http://man.archlinux.org/man/bash.1">bash</a>: <a href="http://man.archlinux.org/man/bash.1#echo%7e2">echo</a>, <a href="http://man.archlinux.org/man/bash.1#exit">exit</a>
 </li>
 <li><a href="http://man.archlinux.org/man/cat.1">cat</a>
 </li>
 <li><a href="http://man.archlinux.org/man/chmod.1">chmod</a>
 </li>
 <li><a href="http://man.archlinux.org/man/curl.1">curl</a>
 </li>
 <li><a href="http://man.archlinux.org/man/display.1">display</a>
 </li>
 <li><a href="http://man.archlinux.org/man/du.1">du</a>
 </li>
 <li><a href="http://man.archlinux.org/man/env.1">env</a>
 </li>
 <li><a href="http://man.archlinux.org/man/grep.1">grep</a>
 </li>
 <li><a href="http://man.archlinux.org/man/head.1">head</a>
 </li>
 <li><a href="http://man.archlinux.org/man/jar-openjdk22.1">jar</a>
 </li>
 <li><a href="http://man.archlinux.org/man/java-openjdk22.1">java</a>
 </li>
 <li><a href="http://man.archlinux.org/man/ps.1">ps</a>
 </li>
 <li><a href="http://man.archlinux.org/man/rm.1">rm</a>
 </li>
 <li><a href="http://man.archlinux.org/man/sudo.8">sudo</a>
 </li>
 <li><a href="http://man.archlinux.org/man/tail.1">tail</a>
 </li>
 <li><a href="http://man.archlinux.org/man/tee.1">tee</a>
 </li>
 <li><a href="http://man.archlinux.org/man/unzip.1">unzip</a>
 </li>
 <li><a href="http://man.archlinux.org/man/wine.1">wine</a>
 </li>
 <li><a href="http://man.archlinux.org/man/wineserver.1">wineserver</a>
 </li>
 </ul>

</section>
</section>
</div>
</body></html>
